#include <iostream>
#include <vector>
using namespace std;
const int maxn = 1e5+10, inf = 1e7;
int price[maxn], n, m;
int in_rec[maxn];
vector < int > v[maxn];

void dfs(int x) {
    in_rec[x] = 1;
    int first_min = inf, second_min = inf;
    bool bl = 0;
    for (int i : v[x]) {
        if (in_rec[i] == 1) {
            bl = 1;
            continue;
        }
        if (in_rec[i] == 0) dfs(i);
        if (price[i] < first_min) {
            second_min = first_min;
            first_min = price[i];
            continue;
        }
        if (price[i] < second_min) {
            second_min = price[i];
        }
    }
    price[x] = min(price[x], first_min + second_min);
    in_rec[x] = (bl ? 0 : 2);
}

int a, x, y;
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    for (int i = 1 ; i <= n ; ++i)
        cin >> price[i];
    for (int i = 1 ; i <= m ; ++i) {
        cin >> a >> x >> y;
        v[a].push_back(x);
        v[a].push_back(y);
    }
    fill(in_rec, in_rec+maxn, 0);
    dfs(1);
    cout << price[1] << '\n';
    return 0;
}