#include <iostream>
#include <vector>
using namespace std;
const int maxn = 1e5+10, inf = 1e7, buff_size = 2e5;
int buff_ix = buff_size-1;
char buff[buff_size];
void read_char() {
    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;
}
void read_int(int &ret) {
    ret = 0;
    for (; buff[buff_ix] < '0' || buff[buff_ix] > '9'; read_char());
    for (; buff[buff_ix] >= '0' && buff[buff_ix] <= '9'; read_char())
        ret = 10*ret + buff[buff_ix] - '0';
}
int price[maxn], n, m;
int in_rec[maxn];
vector < pair < int, int > > v[maxn];

void dfs(int x) {
    in_rec[x] = 1;
    bool bl = 0;
    for (auto p : v[x]) {
        int y = p.first;
        int z = p.second;
        if (in_rec[y] == 1 || in_rec[z] == 1) {
            bl = 1;
            continue;
        }
        if (in_rec[y] == 0) dfs(y);
        if (in_rec[z] == 0) dfs(z);
        price[x] = min(price[x], price[y] + price[z]);
        
    }
    in_rec[x] = (bl ? 0 : 2);
}

int a, x, y;
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read_int(n);
    read_int(m);
    for (int i = 1 ; i <= n ; ++i)
        read_int(price[i]);
    for (int i = 1 ; i <= m ; ++i) {
        read_int(a);
        read_int(x);
        read_int(y);
        v[a].push_back({x, y});
    }
    fill(in_rec, in_rec+maxn, 0);
    dfs(1);
    cout << price[1] << '\n';
    return 0;
}