#include <iostream>
#include <vector>
#include <queue>
using namespace std;
typedef long long ll;
const ll maxn = 1e5+10, inf = 1e7, buff_size = 2e5;
ll buff_ix = buff_size-1;
char buff[buff_size];
void read_char() {
    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;
}
void read_int(ll &ret) {
    ret = 0;
    for (; buff[buff_ix] < '0' || buff[buff_ix] > '9'; read_char());
    for (; buff[buff_ix] >= '0' && buff[buff_ix] <= '9'; read_char())
        ret = 10*ret + buff[buff_ix] - '0';
}
ll price[maxn], n, m;
ll in_rec[maxn];
vector < pair < ll, ll > > v[maxn];
queue < pair < ll, ll > > q[maxn];
// vruh i koi drug

void dfs(ll x) {
    in_rec[x] = 1;
    for (auto p : v[x]) {
        ll y = p.first; 
        ll z = p.second;
        if (in_rec[y] == 1) q[y].push({x, z});
        if (in_rec[z] == 1) q[z].push({x, y});

        if (in_rec[y] == 0) dfs(y);
        if (in_rec[z] == 0) dfs(z);
        price[x] = min(price[x], price[y] + price[z]);
        
    }
    while (!q[x].empty()) {
        auto top = q[x].front();
        int x1 = top.first;
        int z = top.second;
        q[x].pop();
        price[x1] = min(price[x1], price[x] + price[z]);
    }
    in_rec[x] = 2;
}

ll a, x, y;
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read_int(n);
    read_int(m);
    for (ll i = 1 ; i <= n ; ++i)
        read_int(price[i]);
    for (ll i = 1 ; i <= m ; ++i) {
        read_int(a);
        read_int(x);
        read_int(y);
        v[a].push_back({x, y});
    }
    fill(in_rec, in_rec+maxn, 0);
    dfs(1);
    cout << price[1] << '\n';
    return 0;
}