#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

struct edge
{
    int vr, len;
    edge() {}
    edge(int a, int b)
    {
        vr=a;
        len=b;
    }
};

bool operator<(edge p, edge q)
{
    return p.len>q.len;
}

int n, m;
int predl[150000][4];
bool used[150000];
int dist[150000];
vector<int> gr[150000];
priority_queue<edge> pq;

void Dijkstra()
{
    while(!pq.empty())
    {
        edge teked=pq.top();
        pq.pop();
        if(used[teked.vr]) continue;
        int tvr=teked.vr, tlen=teked.len;
        used[tvr]=1;
        if(tvr==1)
        {
            cout<<dist[1]<<endl;
            exit(0);
        }
        int brs=gr[tvr].size();
        for(int i=0; i<brs; i++)
        {
            int tekpr=gr[tvr][i];
            predl[tekpr][3]++;
            if(predl[tekpr][3]==1) continue;
            int nvr=predl[tekpr][0], vr1=predl[tekpr][1], vr2=predl[tekpr][2];
            if(dist[vr1]+dist[vr2]<dist[nvr])
            {
                dist[nvr]=dist[vr1]+dist[vr2];
                pq.push(edge(nvr, dist[nvr]));
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    for(int i=1; i<=n; i++)
    {
        int cen;
        cin>>cen;
        dist[i]=cen;
        pq.push(edge(i, cen));
    }
    for(int i=0; i<m; i++)
    {
        int vr1, vr2, vr3;
        cin>>vr1>>vr2>>vr3;
        predl[i][0]=vr1;
        predl[i][1]=vr2;
        predl[i][2]=vr3;
        gr[vr2].push_back(i);
        gr[vr3].push_back(i);
    }
    Dijkstra();
    return 0;
}
/**
5 3
5 0 1 2 5
5 2 3
4 2 3
1 4 5

3 1
2 2 1
1 2 3
*/
