#include <bits/stdc++.h>
#define endl '\n'

int n, m;
int c[100001];
int a, x, y;
std::vector<std::pair<int, int> > promos[100001];
long long mem[100001];

long long cost(int index) {
    if (mem[index] != -1) { return mem[index]; }
    long long ans = c[index];
    for (auto promo : promos[index]) {
        ans = std::min(ans, cost(promo.first) + cost(promo.second));
    }
    return mem[index] = ans;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::cin >> n >> m;
    for (int i = 0; i < n; ++ i) {
        std::cin >> c[i];
        mem[i] = -1;
    }
    for (int i = 0; i < m; ++ i) {
        std::cin >> a >> x >> y;
        -- a; --x; -- y;
        promos[a].push_back({x, y});
    }
    std::cout << cost(0) << endl;
    return 0;
}
/*
5 3
5 0 1 2 5
5 2 3
4 2 3
1 4 5

3 1
2 2 1
1 2 3
*/
