#include <iostream>
#include <vector>
using namespace std;
typedef long long ll;
const ll maxn = 1e5+10, inf = 1e15;
ll price[maxn], n, m;
ll in_rec[maxn];
vector < ll > v[maxn];

ll asdf, qwer;
void dfs(ll x) {
    in_rec[x] = 1;
    ll first_min = inf, second_min = inf;
    for (ll i : v[x]) {
        if (in_rec[i] == 1) {
            asdf /= qwer;
        }
        if (in_rec[i] == 0) dfs(i);
        if (price[i] < first_min) {
            second_min = first_min;
            first_min = price[i];
            continue;
        }
        if (price[i] < second_min) {
            second_min = price[i];
        }
    }
    //cout << "price[" << x << "]: " << price[x] << ' ' << first_min << ' ' << second_min << '\n';
    price[x] = min(price[x], first_min + second_min);
    in_rec[x] = 2;
}

ll a, x, y;
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    for (ll i = 1 ; i <= n ; ++i)
        cin >> price[i];
    for (ll i = 1 ; i <= m ; ++i) {
        cin >> a >> x >> y;
        v[a].push_back(x);
        v[a].push_back(y);
    }
    fill(in_rec, in_rec+maxn, 0);
    dfs(1);
    cout << price[1] << '\n';
    return 0;
}

/*
6 4
5 0 3 1 0 99
1 2 3
3 2 4
4 1 6
4 2 5
*/