#include <iostream>
#include <vector>
using namespace std;
const int maxn = 1e5+10, inf = 1e7;
int price[maxn], n, m;
int in_rec[maxn];
vector < pair < int, int > > v[maxn];

void dfs(int x) {
    in_rec[x] = 1;
    bool bl = 0;
    for (auto p : v[x]) {
        int y = p.first;
        int z = p.second;
        if (in_rec[y] == 1 || in_rec[z] == 1) {
            bl = 1;
            continue;
        }
        if (in_rec[y] == 0) dfs(y);
        if (in_rec[z] == 0) dfs(z);
        price[x] = min(price[x], price[y] + price[z]);
        
    }
    in_rec[x] = (bl ? 0 : 2);
}

int a, x, y;
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    for (int i = 1 ; i <= n ; ++i)
        cin >> price[i];
    for (int i = 1 ; i <= m ; ++i) {
        cin >> a >> x >> y;
        v[a].push_back({x, y});
    }
    fill(in_rec, in_rec+maxn, 0);
    dfs(1);
    cout << price[1] << '\n';
    return 0;
}