#include <bits/stdc++.h>
using namespace std;

const long long maxn = 1e5+1, maxm = 120001;
long long n, m, c[maxn], dp[maxn];
struct element
{
    int first;
    int second;
};
unordered_map < long long , vector < pair < long long , long long > > > mymap;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    long long i;
    for(i=1; i<=n; ++i)
    {
        cin >> c[i] ;
    }

    long long a, x, y;
    for(i=1; i<=m; ++i)
    {
        cin >> a >> x >> y ;
        mymap[a].push_back({x,y});
    }
}

long long MIN(long long a, long long b)
{
    return a < b ? a : b;
}

long long min_price(long long s)
{
    if(dp[s] != -1) return dp[s];
    if(mymap[s].size() == 0) return c[s];
    long long i, len = mymap[s].size(), res = -1, t;
    for(i=0; i<len; ++i)
    {
        t = min_price(mymap[s][i].first)+min_price(mymap[s][i].second);
        if(res==-1 || t<res) res = t;
    }
    return (dp[s] = res);
}

void solve()
{
    memset(dp, -1, sizeof(dp));
    long long ans = MIN(c[1] , min_price(1));
    cout << ans << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}
