#include <bits/stdc++.h>
using namespace std;

const long long maxn = 1e5+1, maxm = 120001;
long long n, m, c[maxn], dp[maxn];
unordered_map < long long , vector < pair < long long , long long > > > mymap;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    long long i;
    for(i=1; i<=n; ++i)
    {
        cin >> c[i] ;
    }

    long long a, x, y;
    for(i=1; i<=m; ++i)
    {
        cin >> a >> x >> y ;
        mymap[a].push_back({x,y});
    }
}

void min_price(long long s)
{
    if(dp[s] != -1) return;
    if(mymap[s].size() == 0)
    {
        dp[s] = c[s];
        return;
    }
    long long i, len = mymap[s].size(), t, x, y;
    for(i=0; i<len; ++i)
    {
        x = mymap[s][i].first;
        y = mymap[s][i].second;
        min_price(x);
        min_price(y);
        t = dp[x]+dp[y];
        if(dp[s]==-1 || t<dp[s]) dp[s] = t;
    }
}

void solve()
{
    memset(dp, -1, sizeof(dp));
    min_price(1);
    cout << (dp[1]<c[1] ? dp[1] : c[1]) << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}
